#!/bin/env python

import serial
import sys


#port = '/dev/ttyS0'
port = '/dev/ttyUSB0'
baud = 1200
hwflow = False
remote_tx = True
local_tx = True
remote_rx_flow = True
local_tx_flow = True
rts_state = True

STX = b'\x02' # request remote to start Tx
ETX = b'\x03' # request remote to end Tx
SYN = b'\x16' # request ignore Rx for period

with serial.Serial(port, baud, timeout=0, rtscts=hwflow) as ser:
    ser.setRTS(True)
    ser.write(STX if remote_tx else ETX)
    try:
        while True:
            for n in range(0, 100):
                if local_tx:
                    l = "{:02d} ABCDEFGHIJKLMNOPQR\r".format(n)
                    ser.write(l.encode('ascii'))

                data = ser.read(1024)
                if data:
                    sys.stderr.write(data.decode('ascii'))

                if remote_rx_flow and n and (n % 32) == 0:
                    ser.write(SYN)
                if local_tx_flow and n and (n % 16) == 0:
                    rts_state = not rts_state
                    ser.setRTS(rts_state)

    finally:
        ser.write(ETX)
